// file: $isip/class/algo/Calculus/calc_01.cc
// version: $Id: calc_01.cc 7507 2001-11-27 19:35:53Z gao $
//

// isip include files
//
#include "Calculus.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 Calculus::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;
 
  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();
  
  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((int32)algorithm_d));
  Console::put(output);
  
  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);
  
  // display the order
  //
  value.assign((int32)order_d);
  output.debugStr(name(), msg_a, L"order_d", value);
  Console::put(output);

  // display delta_win
  //
  value.assign((int32)delta_win_d);
  output.debugStr(name(), msg_a, L"delta_win_d", value);
  Console::put(output);

  // display the denominator scale factor
  //
  value.assign((float64)denom_d);
  output.debugStr(name(), msg_a, L"denom_d", value);
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");

  // decrease indention
  //
  Console::decreaseIndention();
 
  // exit gracefully
  //
  return true;
}
