// file: $isip_ifc/class/algo/CorrelationEntropy/correntp_01.cc
// version: $Id: correntp_01.cc
//

// isip include files
//
#include "CorrelationEntropy.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 CorrelationEntropy::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);

  // display the embedding type
  //
  output.debugStr(name(), msg_a, L"embedding_d",
                  EMBED_MAP.getName((int32)embedding_d));
  Console::put(output);
  
  // display epsilon
  //
  value.assign((int32)epsilon_d);
  output.debugStr(name(), msg_a, L"epsilon_d", value);
  Console::put(output);

  // display embed_dim_min
  //
  value.assign((int32)embed_dim_min_d);
  output.debugStr(name(), msg_a, L"embed_dim_min_d", value);
  Console::put(output);

  // display embed_dim_max
  //
  value.assign((int32)embed_dim_max_d);
  output.debugStr(name(), msg_a, L"embed_dim_max_d", value);
  Console::put(output);

  // display the value of Theiler's correction
  //
  value.assign((int32)theiler_correction_d);
  output.debugStr(name(), msg_a, L"theiler_correction_d", value);
  Console::put(output);

  // display svd_window_size
  //
  value.assign((int32)svd_window_size_d);
  output.debugStr(name(), msg_a, L"svd_window_size_d", value);
  Console::put(output);
  
  // display delay
  //
  value.assign((int32)delay_d);
  output.debugStr(name(), msg_a, L"delay_d", value);
  Console::put(output);

  // display the debug level
  //
  output.debugStr(name(), msg_a, L"debug_level_d",
		  debug_level_d.getName());
  Console::put(output);

  // display the valid flag
  //
  value.assign(is_valid_d);
  output.debugStr(name(), msg_a, L"is_valid_d", value);
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
