// file: $isip_ifc/class/algo/CorrelationIntegral/corrint_01.cc
// version: $Id: corrint_01.cc 10476 2006-03-13 18:48:18Z prasad $
//

// isip include files
//
#include "CorrelationIntegral.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 CorrelationIntegral::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);

  // display the scaling type
  //
  output.debugStr(name(), msg_a, L"scaling_d",
                  SCAL_MAP.getName((int32)scaling_d));
  Console::put(output);
  
  // display the spacing type
  //
  output.debugStr(name(), msg_a, L"spacing_mode_d",
                  SPAC_MAP.getName((int32)spacing_mode_d));
  Console::put(output);
  
  // display epsilon minimum
  //
  value.assign((float32)epsilon_min_d);
  output.debugStr(name(), msg_a, L"epsilon_min_d", value);
  Console::put(output);

  // display epsilon maximum
  //
  value.assign((float32)epsilon_max_d);
  output.debugStr(name(), msg_a, L"epsilon_max_d", value);
  Console::put(output);

  // display resolution of epsilon 
  //
  value.assign((int32)epsilon_res_d);
  output.debugStr(name(), msg_a, L"epsilon_res_d", value);
  Console::put(output);

  // display the value of epsilons 
  //
  epsilon_d.debug(L"epsilon_d"); 

  // display resolution of Theiler's correction
  //
  value.assign((int32)theiler_correction_d);
  output.debugStr(name(), msg_a, L"theiler_correction_d", value);
  Console::put(output);
 
  // display the debug level
  //
  output.debugStr(name(), msg_a, L"debug_level_d",
		  debug_level_d.getName());
  Console::put(output);

  // display the valid flag
  //
  value.assign(is_valid_d);
  output.debugStr(name(), msg_a, L"is_valid_d", value);
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
