// file: $isip_ifc/class/algo/DynamicFilter/lyap_01.cc
// version: $Id: lyap_01.cc 10485 2006-03-15 17:22:34Z srinivas $
//

// isip include files
//
#include "DynamicFilter.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 DynamicFilter::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);
  
  // display the number of neighbors
  //
  value.assign((int32)num_neighbors_d);
  output.debugStr(name(), msg_a, L"num_neighbors_d", value);
  Console::put(output);

  // display the minimum alpha
  //
  value.assign((float32)alpha_min_d);
  output.debugStr(name(), msg_a, L"alpha_min_d", value);
  Console::put(output);  

  // display the maximum alpha
  //
  value.assign((float32)alpha_max_d);
  output.debugStr(name(), msg_a, L"alpha_max_d", value);
  Console::put(output);  

  // display the number of iterations
  //
  value.assign((int32)num_iterations_d);
  output.debugStr(name(), msg_a, L"num_iterations_d", value);
  Console::put(output);  

  // display the number of iterations
  //
  value.assign((int32)num_eigens_d);
  output.debugStr(name(), msg_a, L"num_eigens_d", value);
  Console::put(output);  

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
