// file: $isip/class/algo/Energy/enrgy_01.cc
// version: $Id: enrgy_01.cc 7156 2001-07-07 01:53:51Z picone $
//

// isip include files
//
#include "Energy.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 Energy::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm choice
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);
  
  // display the energy floor
  //
  String value;
  value.assign(floor_d);
  output.debugStr(name(), msg_a, L"floor_d", value);
  Console::put(output);
  
  // display filter-related information
  //
  ma_coef_d.debug(L"ma_coef_d");
  ar_coef_d.debug(L"ar_coef_d");
  ma_mem_d.debug(L"ma_mem_d");
  ar_mem_d.debug(L"ar_mem_d");
  
  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");

  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
