// file: $isip/class/algo/FilterBank/fb_06.cc
// version: $Id: fb_06.cc,v
//

// isip include files
//
#include "FilterBank.h"

// method: getLeadingPad
// 
// arguments: none
//
// return: the number of future frames needed if the filter is anti-causal
//
int32 FilterBank::getLeadingPad() const {

  // declare local variables
  //
  int32 len = filters_d.length();
  int32 max_nframes = (int32)0;

  // compute the maximum future lag
  //
  for ( int32 i = 0; i < len; i++) {
    int32 tmp = filters_d(i).getLeadingPad();
    if (tmp > max_nframes) {
      max_nframes = tmp;
    }
  }
  
  // return the number of maximum frames needed to cover the future lag
  //
  return max_nframes;
}

// method: getTrailingPad
// 
// arguments: none
//
// return: the number of past frames needed
//
int32 FilterBank::getTrailingPad() const {
  
  // declare local variables
  //
  int32 len = filters_d.length();
  int32 max_nframes = (int32)0;
  
  // compute the maximum past lag
  //
  for ( int32 i = 0; i < len; i++) {
    int32 tmp = filters_d(i).getTrailingPad();
    if (tmp > max_nframes) {
      max_nframes = tmp;
    }
  }
  
  // return the number of maximum frames needed to cover the past lag
  //
  return max_nframes;
}
