// file: $isip_ifc/class/algo/MutualInformation/mi_01.cc
// version: $Id: mi_01.cc 10436 2006-02-23 20:12:47Z pannuri $
//

// isip include files
//
#include <Console.h>
#include "MutualInformation.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 MutualInformation::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;
 
  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();
  
  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((int32)algorithm_d));
  Console::put(output);
  
  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);
  
  // display the normalization name
  //
  output.debugStr(name(), msg_a, L"normalization_d",
                  NORM_MAP.getName((int32)normalization_d));
  Console::put(output);
  
  // display the order
  //
  value.assign((int32)order_d);
  output.debugStr(name(), msg_a, L"order_d", value);
  Console::put(output);

  // display the number of bins
  //
  value.assign((int32)num_bins_d);
  output.debugStr(name(), msg_a, L"num_bins_d", value);
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");

 // decrease indention
  //
  Console::decreaseIndention();
 
  // exit gracefully
  //
  return true;
}
