// file: $isip_ifc/class/algo/ParticleFilter/pf_01.cc
// version: $Id: pf_01.cc 10352 2006-01-09 15:36:23Z patil $
//

// isip include files
//
#include "ParticleFilter.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 ParticleFilter::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String output;
  String value;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm choice
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);
  
  // display filter-related information
  //
  // display the order
  //
  value.assign((int32)order_d);
  output.debugStr(name(), msg_a, L"order_d", value);
  Console::put(output);

  // display the number of particles
  //
  value.assign((int32)particles_d);
  output.debugStr(name(), msg_a, L"particles_d", value);
  Console::put(output);
  
  state_mem_d.debug(L"state_d");
  
  trn_d.debug(L"trn_d");
  obs_d.debug(L"obs_d");
  
  obsn_d.debug(L"obsn_d");
  // states_d.debug(L"states_d");
  data_filt_d.debug(L"data_filt_d");

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");

  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
