// file: $isip_ifc/class/algo/Rps/rps_01.cc
// version: $Id: rps_01.cc 10484 2006-03-14 23:50:33Z srinivas $
//

// isip include files
//
#include "Rps.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 Rps::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);
  
  // display the embedding dimension
  //
  value.assign((int32)embed_dimension_d);
  output.debugStr(name(), msg_a, L"embed_dimension_d", value);
  Console::put(output);

  // display the SVD window size
  //
  value.assign((int32)svd_window_size_d);
  output.debugStr(name(), msg_a, L"svd_window_size_d", value);
  Console::put(output);

  // display the delay for embedding
  //
  value.assign((float32)delay_d);
  output.debugStr(name(), msg_a, L"delay_d", value);
  Console::put(output);

  // display SVD threshold
  //
  value.assign((float32)svd_threshold_d);
  output.debugStr(name(), msg_a, L"svd_threshold_d", value);
  Console::put(output);

  // display the accumulators
  //
  accum_buf_d.debug(L"accum_buf_d");
  
  // display the debug level
  //
  output.debugStr(name(), msg_a, L"debug_level_d",
		  debug_level_d.getName());
  Console::put(output);

  // display the valid flag
  //
  value.assign(is_valid_d);
  output.debugStr(name(), msg_a, L"is_valid_d", value);
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
