// file: $isip/class/algo/Statistics/stat_01.cc
// version: $Id: stat_01.cc 8314 2002-07-09 02:19:50Z picone $
//

// isip include files
//
#include "Statistics.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 Statistics::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output the information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();
  
  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);

  // display the accumulators
  //
  accum_sum_d.debug(L"accum_sum_d");
  accum_sumsqr_d.debug(L"accum_sumsqr_d");
  accum_result_d.debug(L"accum_result_d");
  accum_frame_data_d.debug(L"accum_frame_data_d");
  accum_frame_buff_d.debug(L"accum_frame_buff_d");

  // display the counters
  //
  value.assign(accum_samples_d);
  output.debugStr(name(), msg_a, L"accum_samples_d", value);
  Console::put(output);
    
  value.assign(accum_frames_d);
  output.debugStr(name(), msg_a, L"accum_frames_d", value);
  Console::put(output);
    
  // display the calculation status
  //
  value.assign(is_calculated_d);
  output.debugStr(name(), msg_a, L"is_calculated_d", value);
  Console::put(output);
    
  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease indention
  //
  Console::decreaseIndention();
  
  // exit gracefully
  //
  return true;
}
