// file: $ISIP_IFC/class/java/ConfigPanel/ConfigData.java
// version: $Id: ConfigData.java 10227 2005-09-09 19:07:49Z stanley $

// import necessary java libraries
//
import java.util.*;

public class ConfigData {

    //-------------------------------------------------------------------------
    //
    // public constants
    //
    //-------------------------------------------------------------------------

    /**
     * The constant for initialization value
     */
    public static final int INIT_CAPACITY = 100;
    
    /**
     * The constant for incremental value
     */
    public static final int INCREMENTAL = 50;

    //------------------------------------------------------------------------
    //
    // protected data
    //
    //-----------------------------------------------------------------------


    // vectors of information parsed from the gui resources file
    //
    /**
     * Association related to the data.
     */
    protected Vector<Object> association_d;

    /**
     * Name related to the data
     */
    protected Vector<Object> name_d;

    /**
     * Type related to the data.
     */
    protected Vector<Object> type_d;

    /**
     * Values related to the data.
     */
    protected Vector<Object> value_d;
   
    /**
     * Values related to the data.
     */
    protected String demo_name_d;

    //-------------------------------------------------------------------------
    //
    // public methods
    //
    //-------------------------------------------------------------------------
       
    /**
     * Constructor, use the default data format.
     */ 
    public ConfigData() {

	// initialize the data containers
	//
	init();
    }

    /**
     * Initialize the data.
     *
     * @return a boolean value indicating status.
     */
    public boolean init() {

	// initialize the data containers
	//
	association_d = new Vector<Object>(INIT_CAPACITY, INCREMENTAL);
	name_d = new Vector<Object>(INIT_CAPACITY, INCREMENTAL);
	type_d = new Vector<Object>(INIT_CAPACITY, INCREMENTAL);
	value_d = new Vector<Object>(INIT_CAPACITY, INCREMENTAL);

	return true;
    }

    /**
     * Get the association related to this data.
     *
     * @return a Vector to represent the association.
     */
    public Vector<Object> getAssociation() {
	return association_d;
    }

    /**
     * Get the name related to this data.
     *
     * @return a Vector to represent the name.
     */
    public Vector<Object> getName() {
	return name_d;
    }

    /**
     * Get the type related to this data.
     *
     * @return a Vector to represent the type.
     */
    public Vector<Object> getType() {
	return type_d;
    }

    /**
     * Get the values related to this data.
     *
     * @return a Vector to represent the value.
     */
    public Vector<Object> getValue() {
	return value_d;
    }

   


} // end of class

