// file: $ISIP_IFC/class/java/ConnectionManager/DemoNetworkListener.java
// version: $Id: DemoNetworkListener.java 9667 2004-07-27 19:16:24Z gao $
   
/**
 * Implementing the <code> DemoNetworkListener </code> interface allows
 * a class to receive network events.
 */
public interface DemoNetworkListener {

    /**
     * Handle received network events.
     *
     * @param event the received network event.
     *
     * @return a boolean value indicating status.
     */
    public boolean networkMessageReceived(DemoNetworkEvent event);

    /**
     * Handle the <code> NETWORK_DISCONNECTED </code> event.
     *
     * @param event the <code> NETWORK_DISCONNECTED </code> event.
     *
     * @return a boolean value indicating status.
     */
    public boolean networkDisconnected(DemoNetworkEvent event);
}
