// file: $ISIP_IFC/class/java/DemoProtocol.java
// version: $Id: DemoProtocol.java 10232 2005-09-13 14:29:50Z stanley $
//

// import necessary java libraries
//
// none

/**
 * The DemoProtocol interface should be implemented by any class whose
 * instances are intended to send messages to or receive messages from
 * ISIP process manager servers.
 */
public interface DemoProtocol {
    
    //-------------------------------------------------------------------------
    //
    // public constants
    //
    //-------------------------------------------------------------------------
    /**
     * Message intended to set up the servers.
     */
    public static final int MSG_SET_SERVER = 0;

    /**
     * Message intended to kill the servers.
     */
    public static final int MSG_KILL_SERVER = 10;
    
    /**
     * Message intended to set name for a server.
     */
    public static final int MSG_SET_NAME = 20;

    /**
     * Message intended to set the hub port number.
     */
    public static final int MSG_SET_HUB_PORT = 22;
    
    /**
     * Message intended to init player class.
     */
    public static final int MSG_INIT_PLAYER = 30;
    
    /**
     * Message intended to start dialog servers.
     */
    public static final int MSG_START_DIALOG_NAVIGATION = 40;
    
    /**
     * Message intended to start verification servers.
     */
    public static final int MSG_START_SPEAKER_VERIFICATION = 50;

    /**
     * Message intended to start speech analysis servers.
     */
    public static final int MSG_START_SPEECH_ANALYSIS = 60;

    /**
     * Message intended to start speech recognition servers.
     */
    public static final int MSG_START_SPEECH_RECOGNITION = 62;

    /**
     * Message intended to start speech recognition servers.
     */
    public static final int MSG_START_DEMO = 63;
    
    /**
     * Message intended to send/receive local ip address for this
     * client.
     */
    public static final int MSG_CLIENT_IP_ADDRESS = 70;

    /**
     * Message intended to send/receive port number for this client.
     */
    public static final int MSG_CLIENT_PORT = 80;

    /**
     * Message designed for verification demo.
     */
    public static final int DEMO_SPEAKER_VERIFICATION = 100;

    /**
     * Message designed for dialog.
     */
    public static final int DEMO_DIALOG_NAVIGATION = 101;

    /**
     * Message designed for speech analysis demo.
     */
    public static final int DEMO_SPEECH_ANALYSIS = 102;

    /**
     * Message designed for speech recognition demo.
     */
    public static final int DEMO_SPEECH_RECOGNITION = 104;

    /**
     * Message designed for initial value of demo
     */
    public static final int DEMO_UNDEFINED = 200;

    /**
     * Message designed for server failure msg to client
     */
    public static final int MSG_SERVER_FAILURE = 210;

    /**
     * Message designed for data to be sent
     * Layout of message is MSG_DATA|<tag>|<data>
     * such as "MSG_DATA|server_name|isip_database"
     */
    public static final int MSG_DATA = 220;
}
