// file: $isip/class/asr/AnnotationIndex/andx_01.cc
// version: $Id: andx_01.cc 9031 2003-02-18 19:03:05Z alphonso $
//

// isip include files
//
#include "AnnotationIndex.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* message: (input) information message
//
// return: a bool8 value indicating status
//
// this method dumps the contents of an object to the console
//
bool8 AnnotationIndex::debug(const unichar* msg_a) const {
  
  // build a debug string
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();
  
  ancrset_d.debug(L"ancrset_d");
  ancr_by_id_d.debug(L"ancr_by_id_d");
  ancrset_by_offset_d.debug(L"ancrset_by_offset_d");
  anno_by_id_d.debug(L"anno_by_id_d");
  anno_by_type_d.debug(L"anno_by_type_d");
  start_by_offset_d.debug(L"start_by_offset_d");
  end_by_offset_d.debug(L"end_by_offset_d");
  by_feature_d.debug(L"by_feature_d");
  
  // decrease the indentation
  //  
  Console::decreaseIndention();
  
  // exit gracefully
  //
  return true;
}
