// file: $isip/class/mmedia/Splitter/splt_04.cc
// version: $Id: splt_04.cc 9965 2005-02-11 21:48:47Z raghavan $
//

// isip include files
//
#include "Splitter.h"

// method: write
//
// arguments:
//  Sof& sof: (input) sof file object
//  int32 tag: (input) sof object instance tag
//  const String& name: (input) sof object instance name
//
// return: bool8 value indicating status
//
// this method has the object write itself to an Sof file
//
bool8 Splitter::write(Sof& sof_a, int32 tag_a,
		       const String& name_a) const {

  int32 obj_size = 0;
  
  // write the instance of the object into the Sof file
  //
  if (sof_a.isText()) {

    // set the size to by dynamic
    //
    obj_size = Sof::ANY_SIZE;
  }
  else {

    // the size index and the size of each element
    //
    obj_size = sofSize();
  }

  // write the object into the sof file's index
  //
  if (!sof_a.put(name_a, tag_a, obj_size)) {
    return false;
  }
  
  // exit gracefully
  //
  return writeData(sof_a);
}

// method: writeData
//
// arguments:
//  Sof& sof: (input) sof file object
//  const String& pname: (input) parameter name
//
// return: bool8 value indicating status
//
// this method has the object write itself to an Sof file. it assumes
// that the Sof file is already positioned correctly.
//
bool8 Splitter::writeData(Sof& sof_a, const String& pname_a) const {
  
  // write a start string if necessary
  //
  sof_a.writeLabelPrefix(pname_a);

  // write the split mode
  //
  SPLIT_MAP.writeElementData(sof_a, PARAM_SPLIT_MODE, (int32)split_mode_d);

  // write the machine database
  //
  mdb_d.writeData(sof_a, PARAM_MACHINE_DATABASE);

  // exit gracefully
  //
  return true;
}
