// file: $isip/class/pr/MaximumLikelihoodLinearRegression/mllr_00.cc
// version: $Id: mllr_00.cc 9457 2004-04-19 15:06:59Z gao $
//

// isip include files
//
#include "MaximumLikelihoodLinearRegression.h"

//------------------------------------------------------------------------
//
// required public methods
//
//-----------------------------------------------------------------------

// method: assign
//
// arguments:
//  const MaximumLikelihoodLinearRegression& arg: (input) object to be assigned
//
// return: a bool8 value indicating status
//
// this method assigns the input object to the current object
//
bool8 MaximumLikelihoodLinearRegression::assign(const MaximumLikelihoodLinearRegression& arg_a) {

  // assign data from the input MaximumLikelihoodLinearRegression object
  //
  algorithm_d = arg_a.algorithm_d;
  implementation_d = arg_a.implementation_d;
  
  // exit gracefully
  //
  return true;
}

// method: eq
//
// arguments:
//  const MaximumLikelihoodLinearRegression& arg: (input) object to be compared
//
// return: a bool8 value indicating status
//
// this method checks whether the current object is identical to the
// input object
//
bool8 MaximumLikelihoodLinearRegression::eq(const MaximumLikelihoodLinearRegression& arg_a) const {
  
  // compare the data members
  //
  if ((algorithm_d != arg_a.algorithm_d) ||
      (implementation_d != arg_a.implementation_d)) {
    return false;
  }
  
  // exit gracefully
  //
  return true;
}

// method: clear
//
// arguments:
//  Integral::CMODE ctype: (input) clear mode
//
// return: a bool8 value indicating status
//
// this method resets the data members to the default values
//
bool8 MaximumLikelihoodLinearRegression::clear(Integral::CMODE ctype_a) {
  
  // reset the data members unless the mode is RETAIN
  //
  if (ctype_a != Integral::RETAIN) {
    
    // clear the design parameters
    //
    algorithm_d = DEF_ALGORITHM;
    implementation_d = DEF_IMPLEMENTATION;

    supervision_mode_d = DEF_SUPERVISION_MODE;
    sequence_mode_d = DEF_SEQUENCE_MODE;
    
  }
  
  // exit gracefully
  //
  return true;
}

//-----------------------------------------------------------------------------
//
// we define non-integral constants in the default constructor
//      
//-----------------------------------------------------------------------------

// constants: class name
//
const String MaximumLikelihoodLinearRegression::CLASS_NAME(L"MaximumLikelihoodLinearRegression");

// constants: i/o related constants
//
const String MaximumLikelihoodLinearRegression::DEF_PARAM(L"");
const String MaximumLikelihoodLinearRegression::PARAM_ALGORITHM(L"algorithm");
const String MaximumLikelihoodLinearRegression::PARAM_IMPLEMENTATION(L"implementation");
const String MaximumLikelihoodLinearRegression::PARAM_SUPERVISION_MODE(L"supervision_mode");
const String MaximumLikelihoodLinearRegression::PARAM_SEQUENCE_MODE(L"sequence_mode");
const String MaximumLikelihoodLinearRegression::PARAM_RDT(L"rdt");
const String MaximumLikelihoodLinearRegression::PARAM_SM_ADAPT(L"sm_adapt");
const String MaximumLikelihoodLinearRegression::PARAM_DBGL(L"debug_level");

// constants: other
//

// constants: name map(s) for the enumerated values
//
const NameMap MaximumLikelihoodLinearRegression::ALGO_MAP(L"REGRESSION_TREE, TRANSFORM, ADAPT, ALL");
const NameMap MaximumLikelihoodLinearRegression::IMPL_MAP(L"ML, MEAN, VARIANCE");
const NameMap MaximumLikelihoodLinearRegression::SUP_MODE_MAP(L"SUPERVISED, UNSUPERVISED");
const NameMap MaximumLikelihoodLinearRegression::SEQ_MODE_MAP(L"BATCH, INCREMENTAL");

// static instantiations: memory manager
//
MemoryManager MaximumLikelihoodLinearRegression::mgr_d(sizeof(MaximumLikelihoodLinearRegression), MaximumLikelihoodLinearRegression::name());
