// file: $isip/class/pr/PhoneticDecisionTree/pdt_01.cc
// version: $Id: pdt_01.cc 8677 2002-09-05 20:52:08Z parihar $
//

// isip include files
//
#include "PhoneticDecisionTree.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a bool8 value indicating status
//
bool8 PhoneticDecisionTree::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm choice
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP((int32)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((int32)implementation_d));
  Console::put(output);

  // display the thresholds
  //
  String value;
  value.assign(split_threshold_d);
  output.debugStr(name(), msg_a, L"split_threshold_d", value);
  Console::put(output);

  value.assign(merge_threshold_d);
  output.debugStr(name(), msg_a, L"merge_threshold_d", value);
  Console::put(output);

  value.assign(num_occ_threshold_d);
  output.debugStr(name(), msg_a, L"num_occ_threshold_d", value);
  Console::put(output);

  // print the data
  //
  pdt_rootnode_d.debug(L"pdt_rootnode_d");  
  
  // display the base class
  //
  DecisionTreeBase<PhoneticDecisionTreeNode>::debug(L"DecisionTreeBase");

  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
