// file: $isip/class/pr/RegressionDecisionTreeNode/rdtnod_01.cc
// version: $Id: rdtnod_01.cc 9459 2004-04-19 16:06:08Z gao $
//

// isip include files
//
#include "RegressionDecisionTreeNode.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: logical error status
//
// this is the debug method
//
bool8 RegressionDecisionTreeNode::debug(const unichar* msg_a) const {
  
  // dump the data
  //
  String output;
  String value;

  // write the datapoints
  //
  gaussian_models_d.debug(L"gaussian_models_d");  

  // write the average mean
  //
  average_mean_d.debug(L"average_mean_d");

  // write the node cluster score
  //
  cluster_score_d.debug(L"cluster_score_d");

  // write the node cluster accumulate
  //
  cluster_accumulate_d.debug(L"cluster_accumulate_d");

  // write the node number of components
  //
  number_components_d.debug(L"number_components_d");

  // write the average covariance
  //
  average_covariance_d.debug(L"average_covariance_d");

  // write the speech flag
  //
  speech_flag_d.debug(L"speech_flag_d");

  // write the split flag
  //
  split_flag_d.debug(L"split_flag_d");      

  // write the parent node index
  //
  parent_node_index_d.debug(L"parent_node_index_d");

  // write the transform flag
  //
  transform_flag_d.debug(L"transform_flag_d");

  // write the stat models
  //
  stat_models_d.debug(L"stat_models_d");

  // write the w transform matrix
  //
  w_transform_d.debug(L"w_transform_d");      
  
  // write the best attribute
  //
  value.assign(node_index_d);
  output.debugStr(name(), msg_a, L"node_index_d", value);  
  Console::put(output);

  // display debug level
  //
  output.debugStr(name(), msg_a, L"debug_level_d", debug_level_d.getName());
  Console::put(output);

  // exit gracefully
  //
  return true;
}
