// file: $isip/class/search/HierarchicalDigraph/hd_03.cc
//

// isip include files
//
#include "HierarchicalDigraph.h"

// method: read
//
// arguments:
//  Sof& sof: (input) sof file object
//  int32 tag: (input) sof object instance tag
//  const String& name: (input) sof object instance name
//
// return: a bool8 value indicating status
//
// this method has the object read itself from an Sof file according
// to the specified name and tag
//
bool8 HierarchicalDigraph::read(Sof& sof_a, int32 tag_a,
				  const String& name_a) {

  // get the instance of the object from the Sof file
  //
  if (!sof_a.find(name_a, tag_a)) {
    return false;
  }

  // read the actual data from the sof file
  //
  if (!Vector<SearchLevel>::readData(sof_a)) {
    return false;
  }
  
  // exit gracefully
  //
  return true;
}
