// file: $isip/class/search/HierarchicalDigraph/hd_04.cc
//

// isip include files
//
#include "HierarchicalDigraph.h"

// method: sofSize
//
// arguments: none
//
// return: size of object
//
// this method returns the size of the object in the Sof file and is
// used for binary write
//
int32 HierarchicalDigraph::sofSize() const {
  
  return Vector<SearchLevel>::sofSize();
}
  

// method: write
//
// arguments:
//  Sof& sof: (input) sof file object
//  int32 tag: (input) sof object instance tag
//  const String& name: (input) sof object instance name
//
// return: a bool8 value indicating status
//
// this method has the object write itself to an Sof file
//
bool8 HierarchicalDigraph::write(Sof& sof_a, int32 tag_a,
			   const String& name_a) const {

  int32 obj_size = 0;
  
  // write the instance of the object into the Sof file
  //
  if (sof_a.isText()) {

    // set the size to by dynamic
    //
    obj_size = Sof::ANY_SIZE;
  }
  else {

    // the size index and the size of each element
    //
    obj_size = sofSize();
  }
  
  // write the object into the sof file's index
  //
  if (!sof_a.put(name_a, tag_a, obj_size)) {
    return false;
  }
  
  return Vector<SearchLevel>::writeData(sof_a);
}
