// file: $isip/class/search/SymbolGraphNode/sgrpn_04.cc
// version: $Id: sgrpn_04.cc 9310 2003-09-26 20:20:18Z alphonso $
//

// isip include files
//
#include "SymbolGraphNode.h"
#include <Sof.h>

// method: write
//
// arguments:
//  Sof& sof: (input) sof file object
//  int32 tag: (input) sof object instance tag
//  const String& name: (input) sof object instance name
//
// return: a bool8 indicating status
//
// this method has the object write itself to an Sof file
//
bool8 SymbolGraphNode::write(Sof& sof_a, int32 tag_a,
			    const String& name_a) const {

  int32 obj_size;

  if (sof_a.isText()) {
    obj_size = Sof::ANY_SIZE;
  }
  else {
    obj_size = sofSize();
  }
  
  // put the object into the sof file's index
  //
  if (!sof_a.put(name_a, tag_a, obj_size)) {
    return false;
  }

  // exit gracefully
  //
  return writeData(sof_a);
}

// method: writeData
//
// arguments:
//  Sof& sof: (input) sof file object
//  const String& pname: (input) parameter name
//
// return: logical error status
//
// this method writes the object to the Sof file. it assumes that the
// Sof file is already positioned correctly.
//
bool8 SymbolGraphNode::writeData(Sof& sof_a, const String& pname_a) const {
  
  // exit gracefully
  //
  return true;
}

// method: sofSize
//
// arguments: none
//
// return: size of object
//
// this method returns the size of the object in the Sof file and is
// used for binary write
//
int32 SymbolGraphNode::sofSize() const {

  // count up object by object
  //
  int32 size = 0;

  // return the size
  //
  return size;
}
