;; file: $ISIP_IFC/login/editor_emacs_init.el
;; version: $Id: editor_emacs_init.el 9840 2004-10-17 20:19:47Z parihar $
;;
;; this file creates some local customizations of emacs that are
;; considered standard parts of the isip environment.

;;---------------------------------------------------------------------------;;
;;                                                                           ;;
;; load shareware customizations first                                       ;;
;;                                                                           ;;
;;---------------------------------------------------------------------------;;

;; load url support
;;
(load-library "browse-url")

;;---------------------------------------------------------------------------;;
;;                                                                           ;;
;; load isip customizations last                                             ;;
;;                                                                           ;;
;;---------------------------------------------------------------------------;;

;; load the isip lisp code libraries
;;
(load-file (substitute-in-file-name
	    "$ISIP_IFC/login/editor_emacs_library_general.el"))

;; load the isip emacs modes
;;
(load-file (substitute-in-file-name
	    "$ISIP_IFC/login/editor_emacs_modes.el"))

;; load the isip custom key bindings
;;
(load-file (substitute-in-file-name
	    "$ISIP_IFC/login/editor_emacs_bindings.el"))

;; disable the menu bar
;;
(menu-bar-mode nil)

;; turn on font-lock in all modes that support it
;;
(global-font-lock-mode 1)

;; turn on which-function-mode for all modes that support it
;;
(which-function-mode 't)

;; disable the tool bar as the last symbol definition in this
;; file. the tool bar symbol is not defined for older emacs versions
;; and hence, if run on older emacs version this init script will
;; break only while executing this last symbol definition but will
;; successfully run all the other symbol definitions above it
;;
(tool-bar-mode nil)

;; end of file
;;
