#!/bin/sh
#
# file: $isip/login/x11_twmrc.sh
# version: $Id: x11_twmrc.sh 10218 2005-08-31 16:43:08Z raghavan $
#
# the isip-standard twm init file.
#
# notes:
#
# 07/02/04 (joe picone): streamlined for the Unix migration
# 09/07/00 (bill chapman): change isip005 to isip004
# 07/08/00 (joe picone): modified for the new isip environment
# 07/15/95 (joe picone): first version
#

#------------------------------------------------------------------------------
# this section establishes basic twm characteristics
#------------------------------------------------------------------------------
# show the iconmanager
#
ShowIconManager
IconManagerGeometry	"156x10-0+20"

# define fonts:
#  we used to use 6x13 under sun solaris. however, linux seems
#  to need more specific font specifications
#
TitleFont 		"-adobe-helvetica-bold-r-normal--*-100-*-*-*-*-*-*"
ResizeFont 		"-adobe-helvetica-bold-r-normal--*-100-*-*-*-*-*-*"
MenuFont 		"-adobe-helvetica-bold-r-normal--*-100-*-*-*-*-*-*"
IconFont 		"-adobe-helvetica-bold-r-normal--*-100-*-*-*-*-*-*"
IconManagerFont 	"-adobe-helvetica-bold-r-normal--*-100-*-*-*-*-*-*"

# define window behaviors
#
NoGrabServer
UsePPosition		"non-zero"
DecorateTransients

Color {
    BorderColor		"Black"
    IconBackground	"Black"
    IconBorderColor	"White"
    IconForeground	"White"
    MenuBackground	"White"
    MenuForeground	"Black"
    MenuShadowColor	"Black"
    MenuTitleBackground	"Black"
    MenuTitleForeground	"White"
    TitleBackground	"Black"
    TitleForeground	"White"
}

Pixmaps
    {TitleHighlight "black"}

# define which windows appear with no title
#
NoTitle {
    "TWM Icon Manager"
    "xclock"
    "xisipbiff"
}

# define which tools are managed (displayed) by the iconmanager
#
IconifyByUnmapping

IconManagerDontShow {
    "xclock"
    "xisipbiff"
}

#------------------------------------------------------------------------------
# this section binds the mouse's button keys
#  this was changed on 6/21/95 to make the environment more user-friendly
#  to a two-button mouse
#------------------------------------------------------------------------------
# mouse in root window
#
Button1		=	: root		: f.menu "window operations"
Button2		=	: root		: f.menu "window operations"
Button3		=	: root		: f.menu "utilities"

# mouse on a title bar
#
Button1		=	: title		: f.move
Button2		=	: title		: f.menu "modify window"
Button3		=	: title		: f.menu "modify window"

# other (shift)
#
Button1		= s	: all		: f.zoom
Button2		= s	: all		: f.lower
Button3		= s	: all		: f.raise

#------------------------------------------------------------------------------
# this section defines the window operations (left and middle mouse).
#------------------------------------------------------------------------------

# define the first level of window operations
#
Menu "window operations" {
    "window operations"	f.title
    "new"		f.exec "isip_xterm -tool xterm &"
    "delete"		f.delete
    "destroy"		f.destroy
    "move"		f.move
    "resize"		f.resize
    "refresh"		f.winrefresh
    "iconify"		f.iconify
}

#------------------------------------------------------------------------------
# this section defines the utilities menu (right mouse).
#------------------------------------------------------------------------------

# define the first level of utilities
#
Menu "utilities" {
    "utilities"			f.title
    "emacs"			f.exec "isip_e -tool emacs &"
    "mozilla"			f.exec "mozilla &"
    "groupwise"			f.exec "groupwise &"
    "acroread"			f.exec "acroread4 &"
    "ftp"			f.exec "gftp &"
    "calculator"		f.exec "xcalc &"
    "varmint"                   f.exec "isip_varmint &"
    "screen lock"		f.exec "xterm -iconic -ls -exec xlock -remote -mode blank -nice -19 &"
    "exit twm"			f.quit
    "other twm utilities"	f.menu "twm"
}

Menu "twm" {
    "other twm utilities"	f.title
    "refresh all"		f.refresh
    "restart twm"		f.restart
    "sort icon manager"		f.sorticonmgr
    "twm version"		f.version
}

Menu "modify window" {
    "modify window"		f.title
    "move"			f.move
    "resize"			f.resize
    "iconify"			f.iconify
    "delete"			f.delete
    "destroy"			f.destroy
    "refresh"			f.winrefresh
}

#
# end of file
