// file: $isip/util/demo/isip_comm_data_recorder/isip_data_comm_recorder.h
// version: $Id: isip_comm_signal_detector.h 10401 2006-01-27 19:51:20Z stanley $
//

/*-----------------------------------------------------------------------*
 *                                                                       *
 *                ISIP Communicator Audio Recorder Server                * 
 *									 *
 *-----------------------------------------------------------------------*/

extern "C" {

// system include files 
//
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <strings.h>
#include <time.h>
#include <math.h>

// this line must appear before the galaxy include files
//
#define SERVER_FUNCTIONS_INCLUDE "isip_comm_signal_detector_server.h"
  
  // Galaxy include files
  //
#include <galaxy/util.h>
#include <galaxy/galaxy_all.h>
#include <galaxy/server_functions.h>
};

// isip include files
//
#include <SignalDetector.h>
#include <AudioFile.h>

//AudioFile adf;

// define constants 
//
#define SERVER_NAME "signal_detector"
#define DEBUG 1
#define RECORDED "This utterance is recorded."
#define MAX_UTT_DURATION (float)20    // 20 seconds
#define MAX_LENGTH 256                // max string length
#define NORMALIZATION_VALUE 32767     // 2**15

// declare some global variables for this server
//
char *param_file, param_file_value[MAX_LENGTH];
char audio_logdir_d[MAX_LENGTH]="./logs/";
char client_logdir_d[MAX_LENGTH]="./logs/";
int utt_counter_d = 0;
char filename_d[MAX_LENGTH];
boolean file_open= false;

int total_samples_d = 0;
char acknowledgement_d[MAX_LENGTH];
char server_name_d[MAX_LENGTH];
FILE* client_log_file_d = NULL;
SignalDetector sigd;
long num_utt;
CircularBuffer<Float> cb_d(90000);
int frame_dur_d; 
float sample_rate;

// Usage Information, defined by Galaxy Communicator
// architecture. Used to set more commandline options besides basic
// commandline options of the Galaxy Communicator.
//
static char *oas[] = {
  "-param string", "value of param key to represent decoder", "param",
  NULL
};

// define server state
//
// basically the server works like finite state machine right now
//
// GET_PROCESS_ID   = 0, the server waiting for the query process id
// WAIT_AUDIO_READY = 5, the server waiting for the audio_ready signal
// AUDIO_READY_ACK  = 10, the server send audio_ready signal acknowledgement
//                       signal
// START_RECORDING  = 20, the server send the start recording signal
// START_RECORDING_ACK = 30, the server waiting for start recording signal
//                           acknowledgement
// RAW_DATA = 40, the server waiting for raw data signal
// DATA_ACK = 50, the server send the data acknowledgement signal
// UTTERANCE_END = 60, the server send utterance end acknowledgement signal 

#define GET_PROCESS_ID 0
#define WAIT_AUDIO_READY 5
#define AUDIO_READY_ACK 10
#define START_RECORDING 20
#define START_RECORDING_ACK 30
#define RAW_DATA 40
#define DATA_ACK 50
#define UTTERANCE_END 60

// define a variable to remember server state
//
int server_state_d;

// define the signal process method
//
void process_frame(Gal_Frame frame_a, void *server_data_a);
void state_get_process_id(Gal_Frame frame_a, void *server_data_a);
void state_audio_ready(Gal_Frame frame_a, void *server_data_a);
void state_start_recording_ack(Gal_Frame frame_a, void *server_data_a);
void state_raw_data(Gal_Frame frame_a, void *server_data_a);
boolean load_parameters(String param);
