// file: $PDSP/util/analyze_fft/v1.0/analyze_fft_constants.h
//
 
// make sure this file is only included once
//
#ifndef ISIP_BENCHMARKS
#define ISIP_BENCHMARKS
 
// isip include files
//
#ifndef ISIP_FOURIER_TRANSFORM
#include <FourierTransform.h>
#endif

#ifndef ISIP_COMMAND_LINE
#include <CommandLine.h>
#endif

#ifndef ISIP_LONG
#include <Long.h>
#endif

// required constants
//

// fft specific constants
//
#define FFT_TIMING_RATIO 1000
#define FFT_NUM_ITER 10000

// declare the external functions
//
extern boolean bench_fft(DebugLevel level_a, Long order, String algo_a);
extern boolean fft_get_stats(VectorFloat& input_stats_a, long size_a,
			     float& median_a, float& average_a,
			     float& stddev_a);
extern boolean fft_sort_data(VectorFloat& input_a, long& size_a);


// end of file
//
#endif




