#! @SH@
#

# file: $ISIP_IFC/util/misc/rcs/isip_co.sh
# version: $Id: isip_co.sh 9611 2004-07-03 18:06:03Z picone $
#
# isip_co checks out RCS files and sets a lock
#

# make sure that this directory is not managed by CVS
#
for arg do
   dir=`dirname $arg`;
   cvs_check=`ls $dir | grep CVS`;
   if (test "x$cvs_check" != "x") then

      # give the user an error message
      #
      echo "Files in this directory are managed by CVS, not RCS. Please read"
      echo "organizational policy on the proper use of revision control software."
      # report this infraction to help@isip
      #
      mail help@isip.msstate.edu <<EOF
Subject: CVS/RCS INFRACTION

User $USER tried to rcs the following file(s), one or more of which is
maintained by CVS:

  files = $*
  current directory = `pwd`

Please take appropriate action to preserve repository integrity.

-RCS/CVS watchdog
EOF

      exit 1
   fi
done

# RCS checkout with lock set
#
co -l $*

# Exit Gracefully
#
exit 0
