clc
clear all
addpath('matlab_toolbox/HMMall','matlab_toolbox/HMMall/HMM','matlab_toolbox/HMMall/KPMstats','matlab_toolbox/HMMall/KPMtools','matlab_toolbox/HMMall/netlab3.3');
Qg1=1;
Og1=2;
Mg1=2;
Tg1=1;
Ng1=5000;

  Sigma_G_1(:,:,1,1)=[1 0;0 1];
  Sigma_G_1(:,:,1,2)=[1 0;0 1];
  mu_G_1(:,:,1)=[0;0];
  mu_G_1(:,:,2)=[3;3];
  mixmat_G_1 = [.5 .5];
  prior_G_1= normalise(rand(Qg1,1));
  transmat_G_1= mk_stochastic(rand(Qg1,Qg1));
  
Qg2=1;
Og2=2;
Mg2=2;
Tg2=1;
Ng2=5000;

  Sigma_G_2(:,:,1,1)=[1 0;0 1];
  Sigma_G_2(:,:,1,2)=[1 0;0 1];
  mu_G_2(:,:,1)=[-3;0];
  mu_G_2(:,:,2)=[-3;3];
  mixmat_G_2 = [.3 .7];
  prior_G_2= normalise(rand(Qg1,1));
  transmat_G_2= mk_stochastic(rand(Qg1,Qg1));
   [obs_1, hidden_1] = mhmm_sample(Tg1, Ng1, prior_G_1, transmat_G_1, mu_G_1, Sigma_G_1, mixmat_G_1);
scatter(obs_1(1,1,:),obs_1(2,1,:),10,'.');
hold on
[obs_2, hidden_2] = mhmm_sample(Tg2, Ng2, prior_G_2, transmat_G_2, mu_G_2, Sigma_G_2, mixmat_G_2);
scatter(obs_2(1,1,:),obs_2(2,1,:),10,'R.');


 %collect all genrated sequences in one data set
  k=1;
  for i=1:Ng1
  obs(:,:,k)=obs_1(:,:,i);
  class(k)=1;
  k=k+1;
  end;
  for i=1:Ng2
  obs(:,:,k)=obs_2(:,:,i);
  class(k)=2;
  k=k+1;
  end;
  
   %shuffle the data
  index=randperm(Ng1+Ng2);
  data=obs(:,:,index);
  class=class(index);
  
  
  
  %tarin and test data sets
  %use 30% for testing and 70% for training
  N_test=ceil(0.3*(Ng1+Ng2));
  N_train=(Ng1+Ng2)-N_test;
  
  test_data=data(:,:,1:N_test);
  test_class=class(1:N_test);
  
  train_data=data(:,:,N_test+1:end);
  train_class=class(N_test+1:end);

ind1=find(train_class==1);
  train_data_1=train_data(:,:,ind1);
  nexp_1=length(ind1);
  
  ind2=find(train_class==2);
  train_data_2=train_data(:,:,ind2);
  nexp_2=length(ind2); 
  
  writeSOF('train_data_class1.sof',reshape(train_data_1,[size(train_data_1,1) size(train_data_1,3)])','VectorFloat',1);
  writeSOF('train_data_class2.sof',reshape(train_data_2,[size(train_data_2,1) size(train_data_2,3)])','VectorFloat',1);
  writeSOF('test_data.sof',reshape(test_data,[size(test_data,1) size(test_data,3)])','VectorFloat',1);
  writeSOF('test_class.sof',reshape(test_class,[size(test_class,1) size(test_class,2)])','VectorFloat',0);
  save('data.mat','test_class','test_data','train_class','train_data','train_data_1','train_data_2','N_train','N_test');
  