#include<VectorFloat.h>
#include<MatrixFloat.h>
#include <MixtureModel.h>
#include<Console.h>
#include<CommandLine.h>
#include <iostream>
#include<fstream>
#include<vector>
#include "isip_gmm_demo_support.h"
void loadData(String fileName,long &start_tag,VectorFloat *data,long &buffer_size,long MAX_BUFF,String type)
{
Sof dataFile;
String str;
String vector_name(type);
dataFile.open(fileName);
long tag;
VectorFloat tmp;
long itr=0;
buffer_size=0;
if(start_tag==-1)
{
tag = dataFile.first(vector_name);
}
else
{
tag=start_tag;
}
for (; tag != Sof::NO_TAG;
       tag = dataFile.next(vector_name, tag))
   {

    data[itr].read(dataFile,tag);
 if (itr<MAX_BUFF-1)
{
itr++;
buffer_size++;
}
else{
start_tag=tag+1;
dataFile.close(); 
return;
}

   }
 start_tag=Sof::NO_TAG;
dataFile.close(); 
} 

void computeMeanCov(VectorFloat *data,long data_size,long &total,VectorFloat &mean,MatrixFloat &cov)
{
MatrixFloat mean_square,tmp0;
VectorFloat tmp1;
total+=data_size;

if(data_size>0){

for(long i=0;i<data_size;i++)
{
  mean.add(data[i]);
  tmp0.outerProduct(data[i]);
  cov.add(tmp0);
}


}
else
{
mean.div(total);
cov.div(total);
mean_square.outerProduct(mean);
cov.sub(mean_square);
}

}

void Convert2Diagonal(MatrixFloat &mat)
{
VectorFloat tmp;
mat.getDiagonal(tmp);
mat=0;
mat.setDiagonal(tmp);
mat.assign(mat,Integral::DIAGONAL);
}

void trainModel_step0(MixtureModel &model,VectorFloat *data,long data_size,VectorDouble &params)
{
  VectorDouble params0=params;
  for(long i=0;i<data_size;i++)
  {
    model.accumulate(params0,data[i],false);
   
  }

params=params0;

}

//compute the likelihood
void trainModel_step1(MixtureModel &model,VectorFloat *data,long data_size,double &L)
{
  static long total=0;
  total+=data_size;
  VectorDouble ll;
ll.setLength(data_size); 
 if(data_size>0){
  
 for(long i=0;i<data_size;i++)
  {
    ll(i)=model.getLogLikelihood(data[i]);
  }
 L+=ll.sum();
}
else
{
L=L/(double)total;
total=0;
}
}
void computeLikelihood(MixtureModel &model,VectorFloat *data,long data_size,VectorDouble &L)
{
 
 L.setLength(data_size);   

 for(long i=0;i<data_size;i++)
  {
    L(i)=model.getLogLikelihood(data[i]);
  }
 
}

void decode(VectorDouble L1,VectorDouble L2,VectorFloat &result)
{
long data_size=L1.length();

result.setLength(data_size);
 for(long i=0;i<data_size;i++)
{
if(L1(i)>=L2(i))
 result(i)=1;
else
 result(i)=2;

}
}
void errorCompute(VectorFloat result,VectorFloat *ref,Double &error)
{
static long total=0;
long len=result.length();

if(len>0){
for(long i=0;i<len;i++)
{

if(ref[i]!=result(i))
 error=error+1.0;
total++;

}
}
else
{
error=error/(double)total;
total=0;
}
}

void sendMessage(String msg,DebugLevel verbose,long level)
{
for(int i=0;i<level;i++)
Console::increaseIndention();
if (verbose>=Integral::BRIEF)
Console::broadcast(msg);
else
Console::put(msg);

for(int i=0;i<level;i++)
Console::decreaseIndention();
}

void Tokenize(const string& str,
                      vector<string>& tokens,
                      const string& delimiters)
{

    // Skip delimiters at beginning.
    string::size_type lastPos = str.find_first_not_of(delimiters, 0);
    // Find first "non-delimiter".
    string::size_type pos     = str.find_first_of(delimiters, lastPos);

    while (string::npos != pos || string::npos != lastPos)
    {
        // Found a token, add it to the vector.
        tokens.push_back(str.substr(lastPos, pos - lastPos));
        // Skip delimiters.  Note the "not_of"
        lastPos = str.find_first_not_of(delimiters, pos);
        // Find next "non-delimiter"
        pos = str.find_first_of(delimiters, lastPos);
    }
}
void loadInit(string fileName,VectorFloat &mean1_m1,VectorFloat &mean2_m1,MatrixFloat &cov1_m1,MatrixFloat &cov2_m1,VectorFloat &mean1_m2,VectorFloat &mean2_m2,MatrixFloat &cov1_m2,MatrixFloat &cov2_m2)
{
  string line;

  ifstream myfile;

  vector<string> tokens=vector<string>();
  int model;
  myfile.open((char*)fileName.c_str(),ifstream::in);
  if (myfile.is_open())
  {
    while (myfile.good() )
    {
      
       getline(myfile,line);
       
      Tokenize(line,tokens,"=");
      
      if(tokens[0].compare("model_num")==0)
        {
         model=atoi(tokens[1].c_str());
        } 
      if(tokens[0].compare("mean1")==0)
        {
         long len=tokens[1].length();
         string sub=tokens[1].substr(1,len-2);
         vector<string> tokens2=vector<string>();
         Tokenize(sub,tokens2," ");
         if(model==1){
         for(unsigned int i=0;i<tokens2.size();i++)
         mean1_m1(i)=atof((char*)tokens2[i].c_str());
         }
         if(model==2){
         for(unsigned int i=0;i<tokens2.size();i++)
         mean1_m2(i)=atof((char*)tokens2[i].c_str());
            }
         tokens2.clear();
        } 
      if(tokens[0].compare("mean2")==0)
        {
         long len=tokens[1].length();
         string sub=tokens[1].substr(1,len-2);
         vector<string> tokens2=vector<string>();
         Tokenize(sub,tokens2," ");
         if(model==1){
         for(unsigned int i=0;i<tokens2.size();i++)
         mean2_m1(i)=atof((char*)tokens2[i].c_str());
         }
         if(model==2){
          for(unsigned int i=0;i<tokens2.size();i++)
         mean2_m2(i)=atof((char*)tokens2[i].c_str());
            }
         tokens2.clear();
        } 

     if(tokens[0].compare("cov1")==0)
        {
         long len=tokens[1].length();
         string sub=tokens[1].substr(1,len-2);
         vector<string> tokens2=vector<string>();
         vector<string> tokens3=vector<string>();
         Tokenize(sub,tokens2,";");
        for(unsigned int i=0;i<tokens2.size();i++)
     {
         Tokenize(tokens2[i],tokens3," ");
        if(model==1){
         for(unsigned int j=0;j<tokens3.size();j++)
         cov1_m1.setValue(i,j,atof((char*)tokens3[j].c_str()));
       }
        if(model==2){
         for(unsigned int j=0;j<tokens3.size();j++)
         cov1_m2.setValue(i,j,atof((char*)tokens3[j].c_str()));
       }
       tokens3.clear();
      }
         tokens2.clear();
        } 

     if(tokens[0].compare("cov2")==0)
        {
         long len=tokens[1].length();
         string sub=tokens[1].substr(1,len-2);
         vector<string> tokens2=vector<string>();
         vector<string> tokens3=vector<string>();
         Tokenize(sub,tokens2,";");
        for(unsigned int i=0;i<tokens2.size();i++)
     {
         Tokenize(tokens2[i],tokens3," ");
        if(model==1){
         for(unsigned int j=0;j<tokens3.size();j++)
         cov2_m1.setValue(i,j,atof((char*)tokens3[j].c_str()));
       }
        if(model==2){
         for(unsigned int j=0;j<tokens3.size();j++)
         cov2_m2.setValue(i,j,atof((char*)tokens3[j].c_str()));
       }
       tokens3.clear();
      }
         tokens2.clear();
        } 

    tokens.clear();
    }
    Convert2Diagonal(cov1_m1);
    Convert2Diagonal(cov2_m1);
    Convert2Diagonal(cov1_m2);
    Convert2Diagonal(cov2_m2);
    myfile.close();
  }

 else {
cout << "Unable to open "<<fileName<<"\n";
exit(1);
}
}


void loadInputList(string fileName,String &train_file_1,String &train_file_2,String &test_file_data,String &test_file_class)
{
  string line;

  ifstream myfile;
  int model;
  myfile.open((char*)fileName.c_str(),ifstream::in);
  if (myfile.is_open())
  {
    while (myfile.good() )
    {
      getline(myfile,line);
       
     string  sub;
     sub=line.substr(0,1); 
     if(sub.compare("#")!=0)
     {
     
     train_file_1.assign((byte8*)(char*)line.c_str());
     getline(myfile,line);
     train_file_2.assign((byte8*)(char*)line.c_str());
     getline(myfile,line);
     test_file_data.assign((byte8*)(char*)line.c_str());
     getline(myfile,line);
     test_file_class.assign((byte8*)(char*)line.c_str());
     return;
     }     

      
   
    }
   
    myfile.close();
  }

 else {
cout << "Unable to open "<<fileName<<"\n";
exit(1);
}

}


