// file: isip_posterior_creator.h
//
// this is the header file for the isip_recognize utility
//
// make sure the file is included only once
//
#ifndef ISIP_UTIL_POSTERIOR_CREATOR
#define ISIP_UTIL_POSTERIOR_CREATOR

// isip include files
//
#include <CommandLine.h>
#include <NonlinearOptimization.h>
#include <Sigmoid.h>
#include <Histogram.h>
#include <FeatureFile.h>
#include <StatisticalModel.h>
#include <SupportVectorModel.h>

static const String PROG_NAME(L"isip_posterior_creator");
static const String OPTION_MODEL_FILE(L"model_file");
static const String OPTION_OUTPUT_FILE(L"output_file");
static const String OPTION_OUTPUT_TYPE(L"output_type");
static const String OPTION_POS_EXAMPLE_LIST(L"pos_examples");
static const String OPTION_NEG_EXAMPLE_LIST(L"neg_examples");
static const String OPTION_POS_PRIOR(L"pos_prior");
static const String OPTION_NEG_PRIOR(L"neg_prior");
static const String OPTION_BIN_WIDTH(L"bin_width");
static const String OPTION_DEBUG_LEVEL(L"debug_level");
static const String OPTION_VERBOSITY_LEVEL(L"verbose");
static const String OPTION_LOG_FILE(L"log_file");

static const String OPTION_TYPE_TEXT(L"TEXT");
static const String OPTION_TYPE_BINARY(L"BINARY");

static const double DEF_PRIORI_PROBABILITY = 10000;
static const double DEF_HISTOGRAM_BIN_WIDTH = 0.05;
static const long DEF_CAPACITY = 10000;
static const double DEF_MIN_PROB = 0.0000001;
static const double DEF_CONVERGENCE_THRESHOLD = 0.00001;

static const String EMPTY(String::NULL_STRING);
static const String LOG_FILE_DEFAULT(L"-");

static const Integral::DEBUG DEBUG_LEVEL_DEFAULT=Integral::NONE;
static const Integral::DEBUG VERBOSITY_LEVEL_DEFAULT=Integral::NONE;

// end of file
//
#endif
