// file: decision_tree_constants.h
//
// this is the header file for the decision tree class constants
//

// make sure definitions are only made once
//
#ifndef __ISIP_DECISION_TREE_CONSTANTS
#define __ISIP_DECISION_TREE_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// define the class name
//
#define DT_CLASS_NAME (char_1*)"decision_tree"

// define default threshold value
//
#define DT_DEFAULT_SPLIT_THRESHOLD  (float_4)10;
#define DT_DEFAULT_MERGE_THRESHOLD  (float_4)5;
#define DT_DEFAULT_NUM_OCC_THRESHOLD  (float_4)100.0;

// define default number of phone size
//
#define DT_PHONE_SIZE 2
#define DT_NUM_STATES 1 

// define formats for the tree nodes
//
#define DT_NON_LEAF_FORMAT (char_1*)"N=%ld Level=%ld LF=N Y_CH=%ld N_CH=%ld Q=%s\n"
#define DT_LEAF_FORMAT (char_1*)"N=%ld Level=%ld LF=Y State=%ld\n"

// end of file
// 
#endif
