// file: dec_prune_2.cc
//

// isip include files
//
#include "decoder.h"
#include "decoder_constants.h"

// method: set_beam_cc
//
// arguments:
//  int_4 level: (input) the level at which the beam works
//
// return: a logical_1 to indicate status
//
// this method sets the pruning beam threshold score at the specified
// level
//
logical_1 Decoder::set_beam_cc(int_4 level_a) {

  // find the beam pruning score for pruning at the specified level
  //
  if (beam_d[level_a] != (float_4)0) {
    beam_thresh_d[level_a] = max_score_d[level_a] + beam_d[level_a];
    max_score_d[level_a] = DEC_DEFAULT_SCORE;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
