// file: hist_cstr_2.cc
//

// isip include files
//
#include "history.h"
#include "history_constants.h"

// method: constructor
//
// arguments:
//  History& history : (input) the history to be copied
//
// return: none
//
// this is a copy constructor
//
History::History(History& history_a) {

  // clear the current 
  //
  clear_cc();
  
  // copy the parameters
  //  
  level_d = history_a.level_d;
  phone_index_d = history_a.phone_index_d;
  state_index_d = history_a.state_index_d;
  
  // set the words
  //
  histwords_d = history_a.histwords_d;
  type_d = history_a.type_d;
  hist_len_d = history_a.hist_len_d;
  
  // set the previous history nodes information
  //
  hist_num_d = history_a.hist_num_d;
  prev_d = history_a.prev_d;
  prevsc_d = history_a.prevsc_d;
  
  // set the information necessary during back-tracking
  //
  frame_index_d = history_a.frame_index_d;
  score_d = history_a.score_d;
  ref_count_d = history_a.ref_count_d;
  
  // exit gracefully
  //
}
