// file: history_constants.h
//

// make sure definitions are only made once
//
#ifndef __HISTORY_CONSTANTS
#define __HISTORY_CONSTANTS

// isip include files
//
#ifndef __INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

#ifndef __ISIP_LINK_NODE_CONSTANTS
#include <link_node_constants.h>
#endif

// define the class name
//
#define HISTORY_CLASS_NAME (char_1*)"History"

// define constants for the default levels and indices
//
#define HISTORY_DEFAULT_INDEX (int_4)-1
#define HISTORY_DEFAULT_SCORE (float_4)0

#define HISTORY_STATE_LEVEL (int_4)0
#define HISTORY_MODEL_LEVEL (int_4)1
#define HISTORY_WORD_LEVEL (int_4)2
#define HISTORY_NUM_LEVELS (int_4)3

#define HISTORY_NGRAM ISIP_TRUE
#define HISTORY_WORDGRAPH ISIP_FALSE

// define the default length of histories
//
#define HISTORY_DEFAULT_LEN (int_4)0

// end of file
// 
#endif
