// file: inst_size_0.cc
//

// isip include files
//
#include "instance.h"
#include "instance_constants.h"

// method: size_cc
//
// arguments: none
//
// return: an int_4 with number of bytes used by this object
//
// this method counts the size of the current object in bytes
//
int_4 Instance::size_cc() {

  // set the size variable
  //
  int_4 size = 0;
  
  // add the size of each constituent data
  //   
  size += sizeof(Lex_node*);                     // lex_node_d          
  size += sizeof(int_4);                         // phone_index_d
  size += sizeof(Link_list*);                    // token_list_d
  size += sizeof(float_4);                       // max_score_d
  size += sizeof(float_4);                       // lm_score_d
  size += sizeof(int_4);                         // frame_d

  // exit gracefully
  //
  return size;
}
