// file: lat_cstr_1.cc
//

// isip include files
//
#include "lattice.h"
#include "lattice_constants.h"

// method: default constructor
//
// arguments: none
//
// return: none
//
// this is the default constructor
//
Lattice::Lattice() {

  // set node statistics
  //
  num_arcs_d = LATTICE_DEFAULT_NUM_ARCS;
  num_nodes_d = LATTICE_DEFAULT_NUM_NODES;

  // set node pointers
  //
  lnode_d = (Hash_table*)NULL;
  start_node_d = (Lattice_node*)NULL;

  // set lattice generation infrmation
  //
  lang_model_d = (char_1*)NULL;
  utterance_d = (char_1*)NULL;
  model_set_d = (char_1*)NULL;
  name_d = (char_1*)NULL;
  null_word_d = (Word*)NULL;
  
  // set likelihood scale factors
  //
  lm_scale_d = LATTICE_DEFAULT_SCALE;
  word_penalty_d = LATTICE_DEFAULT_PENALTY;
  
  // exit gracefully
  //
}
