// file: latn_cstr_1.cc
//

// isip include files
//
#include "lattice_node.h"
#include "lattice_node_constants.h"

#include <lex_tree.h>
#include <lex_tree_constants.h>

// method: default constructor
//
// arguments: none
//
// return: none
//
// this is the default constructor
//
Lattice_node::Lattice_node() {

  // set node identity
  //
  type_d = LATTICE_NODE_DEFAULT_TYPE;
  word_d = (Word*)NULL;
  pron_variant_d = LATTICE_NODE_DEFAULT_PRON_VAR;
  frame_d = LATTICE_NODE_DEFAULT_FRAME;
  node_index_d = LATTICE_NODE_DEFAULT_INDEX;
  num_arcs_in_d = LATTICE_NODE_DEFAULT_NUM_ARCS_IN;
  num_arcs_out_d = LATTICE_NODE_DEFAULT_NUM_ARCS_OUT;
  
  // set node pointers
  //
  prev_nodes_d = (Link_list*)NULL;
  next_nodes_d = (Link_list*)NULL;

  // set the lexical tree
  //
  lex_tree_d = (Lex_tree*)NULL;

  // set the lm and ac scores array
  //
  lm_scores_d = (float_4*)NULL;
  ac_scores_d = (float_4*)NULL;
 
  // exit gracefully
  //
}

