// file: lxn_node_1.cc
//

// isip include files
//
#include "lex_node.h"
#include "lex_node_constants.h"

// method: get_node_cc
//
// arguments:
//  int_4 phone : (input) the monophone index
//
// return: a Lex_node* pointing to the lexical tree node with this
// phone
//
// this method searches all the child nodes of the current node for
// the specified phone and returns the match. if no such node exists,
// returns NULL
//
Lex_node* Lex_node::get_node_cc(int_4 phone_a) {

  // dummy variables
  //
  Lex_node* node = (Lex_node*)NULL;
  Lex_node* lxn = (Lex_node*)NULL;

  // make sure the link list of children exists
  //
  if (child_d != (Link_list*)NULL) {
    
    // loop over all the child lex nodes
    //
    for (Link_node* nd = child_d->get_head_cc(); nd != (Link_node*)NULL;
	 nd = nd->get_next_cc()) {
      
      // get the lexical node in this node
      //
      lxn = (Lex_node*)(nd->get_item_cc());

      // stop if the phone here matches the input phone
      //
      if (lxn->get_phone_cc() == phone_a) {
	node = lxn;
	break;
      }
    } // end for loop
  } // end if child_d is not NULL

  // return child node and exit gracefully
  //
  return node;
}
