// file: spmtch_get_0.cc
//

// isip include files
//
#include "subpath_match.h"
#include "subpath_match_constants.h"

// method: get_start_time_cc
//
// arguments: none
//  
// return: an int_4 with the start time of the match
//
// this method gets the start time of a subpath match in a lattice
//
int_4 Subpath_match::get_start_time_cc() {

  // exit gracefully
  //
  return start_time_d;
}

// method: get_end_time_cc
//
// arguments: none
//  
// return: an int_4 with the end time of the match
//
// this method gets the end time of a subpath match in a lattice
//
int_4 Subpath_match::get_end_time_cc() {

  // exit gracefully
  //
  return end_time_d;
}

// method: get_score_cc
//
// arguments: none
//  
// return: a float_4 with the score of the match
//
// this method gets the score of a subpath match in a lattice
//
float_4 Subpath_match::get_score_cc() {

  // exit gracefully
  //
  return score_d;
}

// method: get_num_models_cc
//
// arguments: none
//  
// return: an int_4 the number of models in this subpath match
//
// this method gets the number of acoustic models involved in this match
//
int_4 Subpath_match::get_num_models_cc() {

  // exit gracefully
  //
  return num_models_d;
}

// method: get_start_time_pad_cc
//
// arguments: none
//  
// return: an int_4 with the start time padding used for match comparison
//
// this method gets the start time padding which is used for comparing matches
//
int_4 Subpath_match::get_start_time_pad_cc() {

  // exit gracefully
  //
  return start_time_pad_d;
}

// method: get_end_time_pad_cc
//
// arguments: none
//  
// return: an int_4 with the end time padding used for match comparison
//
// this method gets the end time padding which is used for comparing matches
//
int_4 Subpath_match::get_end_time_pad_cc() {

  // exit gracefully
  //
  return end_time_pad_d;
}
