// file: tr_latn_cstr_2.cc
//

// isip include files
//
#include "train_lattice_node.h"
#include "train_lattice_node_constants.h"

#include <train_lex_tree.h>
#include <train_lex_tree_constants.h>

// method: overloaded constructor
//
// arguments:
//  int_4 node_index_a: (input) node index of the node
//
// return: none
//
// this is the overloaded constructor which also sets the node index to a
// specified value
//
Train_Lattice_node::Train_Lattice_node(int_4 node_index_a) {

  // set node identity
  //
  type_d = TRAIN_LATTICE_NODE_DEFAULT_TYPE;
  word_d = (Train_Word*)NULL;
  pron_variant_d = TRAIN_LATTICE_NODE_DEFAULT_PRON_VAR;
  frame_d = TRAIN_LATTICE_NODE_DEFAULT_FRAME;
  node_index_d = node_index_a;
  num_arcs_in_d = TRAIN_LATTICE_NODE_DEFAULT_NUM_ARCS_IN;
  num_arcs_out_d = TRAIN_LATTICE_NODE_DEFAULT_NUM_ARCS_OUT;
  
  // set node pointers
  //
  prev_nodes_d = (Train_Link_list*)NULL;
  next_nodes_d = (Train_Link_list*)NULL;
  
  // set the lexical tree
  //
  lex_tree_d = (Train_Lex_tree*)NULL;

  // set the lm and ac scores array
  //
  lm_scores_d = (float_8*)NULL;
  ac_scores_d = (float_8*)NULL;

  // exit gracefully
  //
}


