// file: tr_mod_hmm_0.cc
//

// isip include files
//
#include "train_model.h"
#include "train_model_constants.h"

// method: get_output_prob_cc
//
// arguments:
//  int_4 state : (input) the state index for which probability is reqd
//  float_8* data : (input) the acoustic data feature vector
//  int_4 frame : (input) the current frame index
//  int_4& max_mix : (output) the index of the highest mixture corresponding
//                            to the current input state
//
// return: float_8 giving the output probability for the given observation
//
// this methods returns float_8 giving the observation probability for
// the specified state
//
float_8 Train_Model::get_output_prob_cc(int_4 state_a, float_8* data_a,
				  int_4 frame_a, int_4& max_mix_a) {

  // dummy variables
  //
  float_8 score = (float_8)0;

  // evaluate if appropriate
  //
  if ((state_a > (int_4)0) && (state_a < num_states_d)) {
    score = states_d[state_a]->eval_score_cc(data_a, frame_a, max_mix_a);
  }
  
  // return the output probability
  //
  return score;
}
