// file: init_hmm.h
//
// definitions file for the init_hmm
//

// make sure definitions are made only once
//
#ifndef __ISIP_INIT_HMM
#define __ISIP_INIT_HMM

// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

#ifndef __ISIP_EXTRACT_FEATURE
#include <extract_feature.h>
#endif

// system include files
//
#include <memory.h>
#include <ctype.h>

// functions to decipher commandline
//
logical_1 expand_filename_cc(char_1*& fname);
logical_1 read_cmdline_cc(int_4 argc, char_1** argv, char_1* input_file,
			  char_1* state_file, char_1* trans_file,
			  char_1* models_file, char_1* vfloor_file,
			  int_4& mode, int_4& feat_dim, float_4& var_floor,
			  logical_1& delta, logical_1& acc, int_4& delta_win,
			  logical_1& feature_format);

// function to compute the mean and covariance metrix of the feature vectors
// in mfcc files
//
logical_1 compute_cc(FILE* fin, float_4* means, float_4**
		     covar, int_4 num_feat, int_4 mode, logical_1 delta,
		     logical_1 acc, int_4 delta_win, logical_1 feature_format);
logical_1 init_trans_cc(float_4*** trans, int_4 num_trans, int_4* num_st);

// function to print the output
//
logical_1 print_state_cc(FILE* fout, FILE* fvar, float_4* means,
			 float_4** covar, int_4 num_feat, int_4 num_states,
			 float_4 var_floor);
logical_1 print_trans_cc(FILE* fout, float_4*** trans, int_4 num_trans,
			 int_4* num_st_in_model); 
		     
// end of file
//
#endif
