// file: init_hmm_constants.h
//
// definitions file for the init_hmm
//

// make sure definition are made only once
//
#ifndef __ISIP_INIT_HMM_CONSTANTS
#define __ISIP_INIT_HMM_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL_CONSTANTS
#include <integral_constants.h>
#endif

// characters used to trigger filename expansion via a system call ---
// since this is expensive, we only want to do it when it is
// absolutely necessary
//
#define IH_ENV_DELIMITERS (char_1*)"$~(){}[]?"

// define the help file
//
#define IH_HELP_FILE (char_1*)"$ISIP_PROTO/doc/init_hmm.help"

// commandline identifiers
//
#define IH_HELP_OPT "-help"
#define IH_INPUT_OPT "-input"
#define IH_STATE_OPT "-state"
#define IH_TRANS_OPT "-trans"
#define IH_MODELS_OPT "-models"
#define IH_NUM_FEAT_OPT "-num_features"
#define IH_VAR_FLOOR_FILE_OPT "-vfloor_file"
#define IH_MODE_OPT "-mode"
#define IH_VAR_FLOOR_OPT "-var_floor"
#define IH_DELTA_WIN_OPT "-delta_win"
#define IH_DELTA_OPT "-delta"
#define IH_ACC_OPT "-acc"
#define IH_HTK_OPT "-htk"

// defaults
//
#define IH_DEF_VEC_DIMEN 39
#define IH_DEF_DELTA_WIN 2
#define IH_DEF_DELTA ISIP_FALSE
#define IH_DEF_ACC ISIP_FALSE
#define IH_DEF_FEATURE_FORMAT IH_ISIP_PROTO_FORMAT
#define IH_ISIP_PROTO_FORMAT ISIP_FALSE
#define IH_HTK_FORMAT ISIP_TRUE

// input feature file modes
//
#define IH_ASCII_MODE 0
#define IH_BINARY_MODE 1
#define IH_ASCII "ascii"
#define IH_BINARY "binary"

// mathematical constants
//
#define IH_LARGE_VALUE (double)1000000
#define IH_SMALL_VALUE (double)-1000000

// memory space declaration constants
//
#define IH_MAX_NUM_MODELS (int_4)99999

// end of file
//
#endif


