// file: keyword_search.h
//
// search for occurences of a keyword given a phone lattice
//

// make sure definitions are made only once
//
#ifndef __ISIP_KEYWORD_SEARCH
#define __ISIP_KEYWORD_SEARCH

// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

// forward declaration of classes
//
#ifndef __ISIP_DECODER
#include <decoder.h>
#endif

// functions to decipher commandline
//
logical_1 read_cmdline_cc(int_4 argc, char_1** argv, char_1*& prm_file);

// functions to read the parameters file
//
logical_1 read_params_cc(FILE* fp, char_1*& monophones_file, 
			 char_1*& word_lex_file, char_1*& lex_file, 
			 char_1*& lm_file, 
			 char_1*& search_words_file, char_1*& input_file, 
			 char_1*& output_file, int_4& ngram, int_4& nbst, 
			 int_4& max_paths, float_8& beam, float_8& lm_scale,
			 float_8& wd_penalty);

// function to handle file i/o
//
logical_1 open_file_cc(FILE*& fp, char_1* file_name, char_1* mode);

// end of file
//
#endif
