// file: ts_state_2.cc
//
// isip include files
//
#include "tie_state.h"
#include "tie_state_constants.h"

// method: print_state_cc
//
// arguments:
//  char_1* file: (output) the new states file
//  State** states : (input) the new states need to be printed out
//  int_4 num_st : (input) the number of total states
//  int_4 num_feat : (input) the number of features
//  logical_1 output_mode : (input) output states file (binary / ascii)
//
// return: a logical flag to indicate success
//
logical_1 print_state_cc(char_1* file_a, State** states_a, int_4 num_st_a,
			 int_4 num_feat_a, logical_1 output_mode_a) {

  // if binary output mode
  //
  if (output_mode_a == TS_BINARY_MODE) {
    print_bin_state_cc(file_a, states_a, num_st_a, num_feat_a);
  }

  // if ascii mode
  //
  else {
    print_ascii_state_cc(file_a, states_a, num_st_a, num_feat_a);
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
